﻿'Exemple d'un mini jeu style FPS non fini
'les commentaires et évolutions du code seront présent dans une prochaine mises à jours

Imports Tzu_Engine
Imports Tzu_Engine.TZGlobal
Imports Tzu_Engine.Mesh
Imports Tzu_Engine.Scene
Imports Tzu_Engine.Texture
Imports Tzu_Engine.Graphics
Imports Tzu_Engine.Shader

Public Class Form1

    Private Engine As TZEngine = TZEngine.GetInstance
    Private Input As TZInput = TZInput.GetInstance

    Private myCamera As TZCamera
    Private Camera_Speed_Def As Single = 6
    Private Camera_Speed As Single
    Private Camera_Rotate As Boolean = True
    Private Camera_MouseState As Vector3

    Private Map As TZMesh

    Private NT As Physic.TZPhysics

    Private NT_Tf As Physic.TZPhysics.SetTransformCB
    Private NT_Fat As Physic.TZPhysics.SetForceAndTorqueCB

    Private NT_Tf_Cam As Physic.TZPhysics.SetTransformCB
    Private NT_Fat_Cam As Physic.TZPhysics.SetForceAndTorqueCB

    Private myScene As TZScene

    'Private meshManag As Mesh.TZMeshManager = Mesh.TZMeshManager.GetInstance

    'Private LightManag As Light.TZLightManager = Light.TZLightManager.GetInstance
    Private Manager As Manager.TZManager

    Private SpotLight As Light.TZLight

    Private Deferred As Graphics.TZDeferredRendering

    Private lights() As Light.TZLight

    Private mythread As Threading.Thread
    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If Engine.DoRender = True Then
            e.Cancel = True
            Engine.Quit()
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
      
        ' Me.Top = 0
        ' Me.Left = 0
        Me.Width = 1280 'My.Computer.Screen.Bounds.Width
        Me.Height = 768 'My.Computer.Screen.Bounds.Height
        Engine.Init(Me.Handle, True)
        Engine.Texture_Filter = eTextureFilter.Anisotropic_x16

        '
        Engine.DoFillLight = False

        ''''
        Engine.UseInstancing = True
        ''''

        Engine.Display_FPS = True
        Engine.Add_MediaPath(My.Application.Info.DirectoryPath & "\..\..\..\media\", True)

        Manager = Tzu_Engine.Manager.TZManager.GetInstance

        Create_Scene()

        myScene.Load()

        Engine.WaitLoad(False, True, True)

        Update_Scene()

        Render_Scene()

    End Sub

    Private Sub Create_Scene()
        Deferred = Graphics.TZDeferredRendering.GetInstance
        'Deferred.AmbienColor = Get_Color(0.025, 0.025, 0.025, 1)

        myScene = New TZScene("myScene")

        Map = New TZMesh("map01.x", "map01")
        Map.Scale = New Vector3(0.01, 0.01, 0.01)
        '

        For i As Integer = 0 To 2          
            Map.Material(i).NormalMap = Manager.TexManag.Load("Concrete1_N.jpg", "map_normalmap")            
            Map.Material(i).GlossMap = Manager.TexManag.Load("system_gloss.jpg", "map_heightmap")
            Map.Material(i).NormalMap_Enable = True
            Map.Material(i).Specular_Enable = True           
            Map.Material(i).Diffuse = Color.White
            Map.Material(i).SpecularSharpness = 10
        Next

        Map.Physic_Type = ePhysicType.Statics
        myScene.Add(Map)

        NT = New Physic.TZPhysics
        NT_Tf = New Physic.TZPhysics.SetTransformCB(AddressOf NT.Callback_SetTransform)
        NT_Fat = New Physic.TZPhysics.SetForceAndTorqueCB(AddressOf NT.Callback_ForceAndTorque)

        NT_Tf_Cam = New Physic.TZPhysics.SetTransformCB(AddressOf NT.Callback_Camera_SetTransform)
        NT_Fat_Cam = New Physic.TZPhysics.SetForceAndTorqueCB(AddressOf NT.Callback_Camera_ForceAndTorque)


        myCamera = New TZCamera("myCamera")
        myCamera.Set_Mode(eCameraMode.First_Person)
        myCamera.Position = New Vector3(-19.88, -4.5, 11) '
        myCamera.Perspective(75, CSng(Me.Width / Me.Height), 0.1, 1000)
        myCamera.LookAt(New Vector3(0, 0, 0))


        SpotLight = New Light.TZLight("myspotlight")
        SpotLight.Type = eLight_Type.Spot
        SpotLight.OuterConeAngle = DegToRad(30)
        SpotLight.InnerConeAngle = DegToRad(15)
        SpotLight.Range = 7
        SpotLight.Falloff = 1
        SpotLight.Diffuse = Color.LightGoldenrodYellow

        SpotLight.Enable = True

        SpotLight.Intensity = 1

        ReDim lights(17)
        For i As Integer = 0 To lights.Length - 1
            lights(i) = New Light.TZLight("RoomLight_" & i)
            lights(i).Type = eLight_Type.Point
            lights(i).Intensity = 0.8
            lights(i).Enable = True
        Next

        lights(0).position = New Vector3(-20, 0, 20)
        lights(0).Diffuse = Color.White
        lights(0).Range = 10

        lights(1).position = New Vector3(-19.88, -4.5, 11)
        lights(1).Diffuse = Color.Red
        lights(1).Range = 2.5


        lights(2).position = New Vector3(-19.88, -4.5, 3.2)
        lights(2).Diffuse = Color.Green
        lights(2).Range = 8

        lights(3).position = New Vector3(-19.88, -4.5, -5.75)
        lights(3).Diffuse = Color.Yellow
        lights(3).Range = 2.5

        lights(4).position = New Vector3(0.5, -4.5, -5.75)
        lights(4).Diffuse = Color.Yellow
        lights(4).Range = 2.5

        lights(5).position = New Vector3(18.5, 0, -15.5)
        lights(5).Diffuse = Color.White
        lights(5).Range = 20

        lights(6).position = New Vector3(13.4, 5.5, 0)
        lights(6).Diffuse = Color.Blue
        lights(6).Range = 4

        lights(7).position = New Vector3(13.4, 5.5, 4)
        lights(7).Diffuse = Color.Blue
        lights(7).Range = 4

        lights(8).position = New Vector3(10.8, 5.5, 6.6)
        lights(8).Diffuse = Color.Blue
        lights(8).Range = 4

        lights(9).position = New Vector3(10.8, 5.5, 10.6)
        lights(9).Diffuse = Color.Blue
        lights(9).Range = 4

        lights(10).position = New Vector3(10.8, 5.5, 14.4)
        lights(10).Diffuse = Color.Violet
        lights(10).Range = 4

        lights(11).position = New Vector3(6, 5.5, 14.4)
        lights(11).Diffuse = Color.Violet
        lights(11).Range = 4

        lights(12).position = New Vector3(2, 5.5, 14.4)
        lights(12).Diffuse = Color.Violet
        lights(12).Range = 4

        lights(13).position = New Vector3(-2, 5.5, 14.4)
        lights(13).Diffuse = Color.Violet
        lights(13).Range = 4

        lights(14).position = New Vector3(-6, 5.5, 14.4)
        lights(14).Diffuse = Color.Violet
        lights(14).Range = 4

        lights(15).position = New Vector3(-7, 5.5, 21)
        lights(15).Diffuse = Color.SeaGreen
        lights(15).Range = 5.5

        lights(16).position = New Vector3(-7, 5.5, 25)
        lights(16).Diffuse = Color.SeaGreen
        lights(16).Range = 4

        lights(17).position = New Vector3(-11, 5.5, 25)
        lights(17).Diffuse = Color.SeaGreen
        lights(17).Range = 5
        '
        'mythread = New Threading.Thread(AddressOf Game_Loop)
        'mythread.Start()
    End Sub

    Private Sub Update_Scene()
        NT.Set_WorldSize(myScene.Bound_Min, myScene.Bound_max)
        'Dim def_mat As Integer = NT.Get_Material_DefaultGroupID
        'NT.Set_Material_DefaultSoftness(def_mat, def_mat, 0)
        'NT.Set_Material_DefaultElasticity(def_mat, def_mat, 0)
        'NT.Set_Material_DefaultCollidable(def_mat, def_mat, 1)
        'NT.Set_Material_DefaultFriction(def_mat, def_mat, 0.7, 0.7)
        'NT.Set_Material_DefaultFriction(def_mat, def_mat,  0, 0)

        Map.Physic_Body = NT.Add_TreeCollision(Map)
        myCamera.Physic_Body = NT.Add_Cam(myCamera, 0.5, 1.75, 1, New Vector3(1, 0, 0), NT_Tf_Cam, NT_Fat_Cam)
        myCamera.Physic_OffsetHeight = 0.5
     
    End Sub

    'Private Sub Game_Loop()
    '    Dim dwCurrentTime, dwLastFrameTime As Integer
    '    Dim dwFPSLimit As Integer = 60
    '    Do While Engine.DoRender


    '        NT.Update(0.001F)
    '        dwLastFrameTime = dwCurrentTime
    '    Loop
    'End Sub
    Private Sub Render_Scene()
        'Dim dwCurrentTime, dwLastFrameTime As Integer
        'Dim dwFPSLimit As Integer = 60
        Dim skycolor As Color = Get_Color(0.6, 0.8, 1, 1)

        Do While Engine.DoRender
            'dwCurrentTime = My.Computer.Clock.TickCount
            'If ((dwCurrentTime - dwLastFrameTime) < (1000 / dwFPSLimit)) Then
            '    Continue Do
            'End If
            'dwLastFrameTime = dwCurrentTime

            If Engine.TestCooperativeLevel Then
                NT.Update(Engine.DeltaTime)

                User_Input()

                Engine.Camera_Update(myCamera, True)
                SpotLight.Direction = myCamera.Look
                SpotLight.position = myCamera.Position

                Deferred.GBuffer_Begin()
                myScene.Render()
                Deferred.GBuffer_End()

                Engine.Render_Clear(skycolor)


                Engine.Render_Begin()


                Deferred.Render()

                Engine.Render_End()

            End If
            Application.DoEvents()
            '  Me.Text = myCamera.Position.ToString

        Loop

        Engine.Dispose()

        Application.Exit()
    End Sub

    Private Sub User_Input()
        If Input.Key(eKeyboard.Echap) Then Engine.Quit()

        If Input.Key_Pressed(eKeyboard.Grave, True) Then
            Engine.Display_Console = Not Engine.Display_Console
        End If
        If Input.Key_Pressed(eKeyboard.F1) Then
            Engine.Display_FPS = Not Engine.Display_FPS
        ElseIf Input.Key_Pressed(eKeyboard.F2) Then
            Engine.Render_BoundingBox = Not Engine.Render_BoundingBox
        ElseIf Input.Key_Pressed(eKeyboard.F3) Then
            myScene.Render_BoundingBox = Not myScene.Render_BoundingBox
        End If
        If Engine.Display_Console = True Then
            Engine.Console_Write = Input.Key_Pressed

            If Input.Key(eKeyboard.Home) Then
                Engine.Console_Maximize()
            ElseIf Input.Key(eKeyboard.Ends) Then
                Engine.Console_Normal()
            End If

            If Input.Key(eKeyboard.Page_Up) Then
                Engine.Console_ScrollLine -= 1
            ElseIf Input.Key(eKeyboard.Page_Down) Then
                Engine.Console_ScrollLine += 1
            End If

        Else
            Camera_Speed = Camera_Speed_Def * Engine.DeltaTime
            Camera_MouseState = Input.Get_MouseState

            If Camera_Rotate = True Then

                myCamera.Rotate(Camera_MouseState.X, Camera_MouseState.Y, 0)
            End If

        
            If Input.Key(eKeyboard.Z) Then
                myCamera.Move(0, 0, Camera_Speed)               
            ElseIf Input.Key(eKeyboard.S) Then
                myCamera.Move(0, 0, -Camera_Speed)
            End If

            If Input.Key(eKeyboard.Q) Then
                myCamera.Move(-Camera_Speed, 0, 0)
            ElseIf Input.Key(eKeyboard.D) Then
                myCamera.Move(Camera_Speed, 0, 0)

            End If

            If Input.Key(eKeyboard.LeftShift) Then
                myCamera.Move(0, Camera_Speed, 0)
            End If
            If Input.Key(eKeyboard.LeftControl) Then
                myCamera.Move(0, -Camera_Speed, 0)
            End If

            If Input.Key_Pressed(eKeyboard.Space) Then
                Camera_Rotate = Not Camera_Rotate
            End If

            If Input.Key_Pressed(eKeyboard.F) Then
                SpotLight.Enable = Not SpotLight.Enable
            End If

        End If

    End Sub


End Class
