﻿'Exemple de plusieurs perso animé
Imports Tzu_Engine

Public Class Form1

    Private Engine As TZEngine = Tzu_Engine.TZEngine.GetInstance

    Private myActor() As Actor.TZActor

    Private myCamera As Scene.TZCamera

    Private myLight As Light.TZLight
    Private cube_test As Mesh.TZMesh
    ' Private cube_Child As Mesh.TZMesh

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Initialisation du moteur en mode fenêtré
        Me.Show()
        Me.Focus()

        Engine.Init(Me.Handle)
        Engine.Console_System = True

        'indique que nous voulons afficher le nombre d'image par seconde
        Engine.Display_FPS = True

        'on indique le dossier des medias
        Engine.Add_MediaPath(My.Application.Info.DirectoryPath & "\..\..\..\media\")

        Randomize()
              
        'on créé une lumière
        myLight = New Light.TZLight("mylight")

        'on utilise une fonction facilitante pour remplir rapidement les valeurs de mylight
        'afin d'obtenir une lumière directionnel
        Light.TZLightManager.GetInstance.Create_DirectionalLight(New Vector3(1, -1, 0), myLight)

        'et on allume la lumière
        Light.TZLightManager.GetInstance.Lightning = True

        'on créé notre camera
        myCamera = New Scene.TZCamera("myCamera")

        'on la positionne
        myCamera.Position = New Vector3(-100, 100, 64)
        myCamera.Perspective(75, CSng(Engine.Viewport_Width / Engine.Viewport_Height), 0.1, 1000)

        'et on lui dit de regarder en direction des nos persos
        myCamera.LookAt(New Vector3(0, 50, 64))


        cube_test = Mesh.TZMeshManager.GetInstance.Load_Cube(80, 15, 150, "cube_test")
        cube_test.Material(0).Diffuse = Color.Black
        cube_test.Position = New Vector3(999, 999, 999)
        cube_test.load()

        'bug toujours
        'cube_Child = Mesh.TZMeshManager.GetInstance.Load_Cube(80, 15, 15, "cube_child")
        'cube_Child.Position = New Vector3(10, 10, 10)
        'cube_Child.Set_Parent(cube_test)

        Render3D()
    End Sub

    Private Sub Render3D()

        'attend que tout est chargé
        Engine.WaitLoad(False, False, True)

        'debut de la boucle de rendu
        Do While Engine.DoRender
            Application.DoEvents()

            's'il n'y a pas de perte du device on peu commencer le rendu
            If Engine.TestCooperativeLevel Then

                'début du rendu
                Engine.Render_Begin()

                'effacement du backbuffer avec une couleur
                Engine.Render_Clear(Color.BlueViolet)

                'on indique au moteur qu'il faut regarder à partir de notre camera            
                Engine.Camera_Update(myCamera, False)

                'rendu des persos
                If Not myActor Is Nothing Then
                    For i As Integer = 0 To myActor.Length - 1
                        myActor(i).Update()
                        myActor(i).Render()
                      
                        cube_test.Matrix_Absolut = myActor(i).Bone_Matrix(33)
                        cube_test.Render()

                        ' cube_Child.Render()

                    Next
                End If
                cube_test.Render()

                'fin du rendu
                Engine.Render_End()

            End If

        Loop

        'on decharge le moteur et tout ces composants interne
        Engine.Dispose()

        Application.Exit()

    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If Engine.DoRender = True Then
            e.Cancel = True

            'indique au moteur que l'on veut quitter
            Engine.Quit()
            'et quant il est pret il passe la valeur Engine.DoRender à False
        End If
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        If myActor Is Nothing Then
            ReDim Preserve myActor(0)
        Else
            ReDim Preserve myActor(myActor.Length)
        End If
        myActor(myActor.Length - 1) = New Actor.TZActor("tiny_4anim.x", "myActor_" & Tzu_Engine.Debug.IndexManager.GetInstance.Get_IndexRND)
        ' myActor(myActor.Length - 1) = New Actor.TZActor("D:\Game Creators Dark GDK\Media\Models\Colonel Z\ColZ.X", "myActor_" & Tzu_Engine.Debug.IndexManager.GetInstance.Get_IndexRND)

        With myActor(myActor.Length - 1)
            .Material(0).Diffuse = Color.White
            .Material(0).Ambient = Color.Black
            ' .OneAnimTrack = True
            .OneTrack_AnimCount = 42
            .OneTrack_SetAnim = CInt(Rnd() * 42)

            .Position = New Vector3(Rnd() * 128, 0, Rnd() * 128)
            .Scale = New Vector3(0.2, 0.2, 0.2)
            '.Scale = New Vector3(0.4, 0.4, 0.4)
            .Rotation = New Vector3(-90, Rnd() * 360, 0)
            .Set_Animation(CByte(Rnd() * 3))
            .load()
            Engine.Load()
        End With

        Button1.Text = "add (" & myActor.Length & ")"
    End Sub
End Class
