﻿'Dans ce premier tutorial nous allons initialiser le moteur
'et écrire le fameux "Hello World" au milieu de la fenetre de rendu
Imports Tzu_Engine

Public Class Form1

    Private Engine As TZEngine = TZEngine.GetInstance

    Private mySprite As Graphics.TZSprite
    Private myText As Graphics.TZText

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'affichage de la console dans la fenêtre de sortie
        Engine.Console_System = True

        'Initialisation du moteur en mode fenêtré
        Engine.Init(Me.Handle)

        'indique que nous voulons afficher le nombre d'image par seconde (et d'autres infos)
        Engine.Display_FPS = True

        'creation de la classe TZSprite qui permet de dessiner en 2d
        mySprite = New Graphics.TZSprite

        'Création de la classe TZText qui permet d'écrire du texte
        'ici nous utilisons la police "arial" d'une taille de 20 et en gras
        myText = New Graphics.TZText("arial", 40, FontStyle.Bold)

        Render3D()
    End Sub

    Private Sub Render3D()

        'attend que tout est chargé
        Engine.WaitLoad(False, False, True)

        'debut de la boucle de rendu
        Do While Engine.DoRender
            Application.DoEvents()

            's'il n'y a pas de perte du device on peu commencer le rendu
            If Engine.TestCooperativeLevel Then

                'début du rendu
                Engine.Render_Begin()

                'effacement du backbuffer avec une couleur
                Engine.Render_Clear(Color.BlueViolet)

                'debut du rendu 2d
                mySprite.Render_Begin(eSpriteFlags.AlphaBlend)
                'on dessine un premier grand rectangle de couleur noir
                mySprite.Draw(New Vector2(150 - 5, 150 - 5), New Vector2(500 + 10, 300 + 10), Color.Black.ToArgb)

                'puis une plus petit rectangle de couleur orange
                mySprite.Draw(New Vector2(150, 150), New Vector2(500, 300), Color.Orange.ToArgb)

                'et on écrit enssuite par dessus notre texte de couleur blanche
                myText.Write(mySprite, "HELLO WORLD !", New Vector2(200, 250), Color.White.ToArgb)

                'fin du rendu 2d
                mySprite.Render_End()

                'fin du rendu
                Engine.Render_End()

            End If

        Loop

        'on decharge le moteur et tout ces composants interne
        Engine.Dispose()

        Application.Exit()

    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If Engine.DoRender = True Then
            e.Cancel = True

            'indique au moteur que l'on veut quitter
            Engine.Quit()
            'et quant il est pret il passe la valeur Engine.DoRender à False
        End If
    End Sub
End Class
