﻿'Dans ce second tutorial nous allons charger un objets 3d préfabriquer (une théière)
'lui appliquer une texture et l'afficher à l'écran
Imports Tzu_Engine

Public Class Form1

    Private Engine As TZEngine = TZEngine.GetInstance

    Private myMesh As Mesh.TZMesh
    Private myCamera As Scene.TZCamera

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Initialisation du moteur en mode fenêtré
        Engine.Init(Me.Handle)

        'indique que nous voulons afficher le nombre d'image par seconde
        Engine.Display_FPS = True

        'on indique le dossier des medias
        Engine.Add_MediaPath(My.Application.Info.DirectoryPath & "\..\..\..\media\")

        'on charge notre théière        
        myMesh = Mesh.TZMeshManager.GetInstance.Load_Teapot("myTeapot")
        myMesh.load()

        'on charge la texture "metal01.jpg" contenu dans le dossier media
        'et on la donne au premier materiaux de notre théière comme texture diffuse
        myMesh.Material(0).DiffuseMap = Texture.TZTextureManager.GetInstance.Load("metal01.jpg", "mytexture")

        'on créé notre camera
        myCamera = New Scene.TZCamera("myCamera")

        'on la positionne au coordonnée X=-2, Y=2, Z=0
        myCamera.Position = New Vector3(-2, 2, 0)

        'et on lui dit de regarder en direction de notre théière
        myCamera.LookAt(myMesh.Position)

        Render3D()
    End Sub

    Private Sub Render3D()

        'attend que tout est chargé
        Engine.WaitLoad(False, False, True)

        'debut de la boucle de rendu
        Do While Engine.DoRender
            Application.DoEvents()

            's'il n'y a pas de perte du device on peu commencer le rendu
            If Engine.TestCooperativeLevel Then

                'début du rendu
                Engine.Render_Begin()

                'effacement du backbuffer avec une couleur
                Engine.Render_Clear(Color.BlueViolet)

                'on indique au moteur qu'il faut regarder à partir de notre camera            
                Engine.Camera_Update(myCamera, False)

                'nous faisons tourner notre théière sur elle même
                myMesh.Rotate_StepY(0.1)

                'et on la dessine
                myMesh.Render()

                'fin du rendu
                Engine.Render_End()

            End If

        Loop

        'on decharge le moteur et tout ces composants interne
        Engine.Dispose()

        Application.Exit()

    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If Engine.DoRender = True Then
            e.Cancel = True

            'indique au moteur que l'on veut quitter
            Engine.Quit()
            'et quant il est pret il passe la valeur Engine.DoRender à False
        End If
    End Sub
End Class
