﻿'Dans ce cinquième tutorial nous allons créer un emetteur de particule
Imports Tzu_Engine

Public Class Form1

    Private Engine As TZEngine = TZEngine.GetInstance

    Private myEmettor As Particle.TZEmettor

    Private myCamera As Scene.TZCamera

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Initialisation du moteur en mode fenêtré
        Engine.Init(Me.Handle, False)

        'indique que nous voulons afficher le nombre d'image par seconde
        Engine.Display_FPS = True

        'on indique le dossier des medias
        Engine.Add_MediaPath(My.Application.Info.DirectoryPath & "\..\..\..\media\")

        'creation de l'emeteur de particule
        myEmettor = New Particle.TZEmettor("mymemet")

        'on donne la texture utilisé par les particules
        myEmettor.Material.DiffuseMap = Texture.TZTextureManager.GetInstance.Load("smoke_particle.png", "part_tex")
        myEmettor.Material.DiffuseMap.ColorKey = Color.White

        'et pour le reste nous laissons les valeurs défini par défaut

        'la methode load permet de charger l'entité
        myEmettor.load()

        'on créé notre camera
        myCamera = New Scene.TZCamera("myCamera")

        'on la positionne au coordonnée X=-100, Y=0, Z=0
        myCamera.Position = New Vector3(-100, 0, 0)

        'et on lui dit de regarder en direction de notre emetteur de particule
        myCamera.LookAt(myEmettor.Position)

        Render3D()
    End Sub

    Private Sub Render3D()

        'attend que tout est chargé
        Engine.WaitLoad(False, False, True)

        'debut de la boucle de rendu
        Do While Engine.DoRender
            Application.DoEvents()

            's'il n'y a pas de perte du device on peu commencer le rendu
            If Engine.TestCooperativeLevel Then

                'début du rendu
                Engine.Render_Begin()

                'effacement du backbuffer avec une couleur
                Engine.Render_Clear(Color.Black)

                'on indique au moteur qu'il faut regarder à partir de notre camera            
                Engine.Camera_Update(myCamera, False)

                'rotation et rendu de l'emetteur de particule
                myEmettor.Rotate_StepY(60 * Engine.DeltaTime)
                myEmettor.Render()

                'fin du rendu
                Engine.Render_End()

            End If

        Loop

        'on decharge le moteur et tout ces composants interne
        Engine.Dispose()

        Application.Exit()

    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If Engine.DoRender = True Then
            e.Cancel = True

            'indique au moteur que l'on veut quitter
            Engine.Quit()
            'et quant il est pret il passe la valeur Engine.DoRender à False
        End If
    End Sub

End Class
