﻿'Dans ce sixieme tutorial nous allons charger un personnage animé
Imports Tzu_Engine

Public Class Form1

    Private Engine As TZEngine = Tzu_Engine.TZEngine.GetInstance

    Private myActor As Actor.TZActor

    Private myCamera As Scene.TZCamera

    Private myLight As Light.TZLight

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Initialisation du moteur en mode fenêtré
        Me.Show()
        Me.Focus()

        Engine.Init(Me.Handle)

        'indique que nous voulons afficher le nombre d'image par seconde
        Engine.Display_FPS = True

        'on indique le dossier des medias
        Engine.Add_MediaPath(My.Application.Info.DirectoryPath & "\..\..\..\media\")

        'on charge notre personnage
        myActor = New Actor.TZActor("tiny_4anim.x", "myActor")
        myActor.Scale = New Vector3(0.2, 0.2, 0.2)
        myActor.Angles = New Vector3(TZGlobal.DegToRad(-90), 0, 0)
        myActor.Set_Animation(2)
        myActor.load()

        'on lui donne du blanc comme couleur diffuse et noir en couleur ambiente
        myActor.Material(0).Diffuse = Color.White
        myActor.Material(0).Ambient = Color.Black

        'on créé une lumière
        myLight = New Light.TZLight("mylight")

        'on utilise une fonction facilitante pour remplir rapidement les valeurs de mylight
        'afin d'obtenir une lumière directionnel
        Light.TZLightManager.GetInstance.Create_DirectionalLight(New Vector3(1, -1, 0), myLight)

        'et on allume la lumière
        Light.TZLightManager.GetInstance.Lightning = True

        'on créé notre camera
        myCamera = New Scene.TZCamera("myCamera")

        'on la positionne au coordonnée X=-20, Y=5, Z=0
        myCamera.Position = New Vector3(-100, 100, 0)

        'et on lui dit de regarder en direction de notre hangar
        myCamera.LookAt(New Vector3(0, 50, 0))

        Render3D()
    End Sub

    Private Sub Render3D()

        'attend que tout est chargé
        Engine.WaitLoad(False, False, True)

        'debut de la boucle de rendu
        Do While Engine.DoRender
            Application.DoEvents()

            's'il n'y a pas de perte du device on peu commencer le rendu
            If Engine.TestCooperativeLevel Then

                'début du rendu
                Engine.Render_Begin()

                'effacement du backbuffer avec une couleur
                Engine.Render_Clear(Color.BlueViolet)

                'on indique au moteur qu'il faut regarder à partir de notre camera            
                Engine.Camera_Update(myCamera, False)

                'nous faisons tourner notre hangar sur lui même en utilisant
                'DeltaTime afin d'avoir une vitesse constante
                myActor.Rotate_StepY(50 * Engine.DeltaTime)

                'met à jours l'animation
                myActor.Update()

                'et on le dessine
                myActor.Render()

                'fin du rendu
                Engine.Render_End()

            End If

        Loop

        'on decharge le moteur et tout ces composants interne
        Engine.Dispose()

        Application.Exit()

    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If Engine.DoRender = True Then
            e.Cancel = True

            'indique au moteur que l'on veut quitter
            Engine.Quit()
            'et quant il est pret il passe la valeur Engine.DoRender à False
        End If
    End Sub
End Class
