﻿'Se 7ême tutorial est un regroupement des précédent tutoriaux avec divers ajouts
Imports Tzu_Engine
Imports Tzu_Engine.TZGlobal

Public Class Form1

    Private Engine As TZEngine = Tzu_Engine.TZEngine.GetInstance

    Private myActor As Actor.TZActor

    Private myCamera As Scene.TZCamera

    Private myLight As Light.TZLight

    Private myTerrain As Terrain.TZTerrain

    Private mySkybox As Sky.TZSkybox

    Private RState As RenderState.TZRenderState = RenderState.TZRenderState.GetInstance

    Private Input As TZInput = TZInput.GetInstance

    Private Camera_Speed_Def As Single = 8
    Private Camera_Speed As Single
    Private Camera_Rotate As Boolean = True
    Private Camera_MouseState As Vector3
    Private Camera_distance As Single = 8

    Private Actor_Speed As Single = 1100

    Private myText As Graphics.TZText

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Initialisation du moteur en mode fenêtré
        Me.Show()
        Me.Focus()
        Engine.Init(Me.Handle)        

     
        'on indique le dossier des medias ainsi que ses sous dossier
        Engine.Add_MediaPath(My.Application.Info.DirectoryPath & "\..\..\..\media\", True)

        'texture de l'écran de chargement
        Engine.WaitLoad_Background_Texture = Texture.TZTextureManager.GetInstance.Load("brickwork-texture.jpg", "brick")

        'on charge notre personnage
        myActor = New Actor.TZActor("tiny_4anim.x", "myActor")
        myActor.Scale = New Vector3(0.01, 0.01, 0.01)
        myActor.Angles = New Vector3(DegToRad(-90), 0, 0)
        myActor.Set_Animation(3)
        myActor.load()

        'on lui donne du blanc comme couleur diffuse et noir en couleur ambiente
        myActor.Material(0).Diffuse = Color.White
        myActor.Material(0).Ambient = Color.DarkGray

        'on place le perso au milieu du terrain
        myActor.Position = New Vector3(1024, 0, 1024)

        'on créé notre terrain
        myTerrain = New Terrain.TZTerrain("montagneheight.jpg", "myterrain", 8, 64, 1)

        'On défini la texture de base qui est étiré sur tout le terrain
        myTerrain.Texture_Base = Texture.TZTextureManager.GetInstance.Load("montagne.jpg", "terrain_texture_base")

        'on ajoute la texture detail qui va ajouter un peu "bruit"
        myTerrain.Texture_Detail = Texture.TZTextureManager.GetInstance.Load("detail.jpg", "mydetailtex")

        'on tile la texture de detail pour qu'elle ce repete 128x128
        myTerrain.Tile_Texture_Detail = 128.0F

        myTerrain.load()

        'création de la skybox
        mySkybox = New Sky.TZSkybox("myskybox")
        mySkybox.Texture(eSkybox.Back) = Texture.TZTextureManager.GetInstance.Load("skybox_back.jpg", "sky_back")
        mySkybox.Texture(eSkybox.Down) = Texture.TZTextureManager.GetInstance.Load("skybox_bottom.jpg", "sky_down")
        mySkybox.Texture(eSkybox.Front) = Texture.TZTextureManager.GetInstance.Load("skybox_front.jpg", "sky_front")
        mySkybox.Texture(eSkybox.Left) = Texture.TZTextureManager.GetInstance.Load("skybox_left.jpg", "sky_left")
        mySkybox.Texture(eSkybox.Right) = Texture.TZTextureManager.GetInstance.Load("skybox_right.jpg", "sky_right")
        mySkybox.Texture(eSkybox.Up) = Texture.TZTextureManager.GetInstance.Load("skybox_top.jpg", "sky_up")

        mySkybox.load()

        'ajout d'un brouillard bleu ciel
        RState.Fog_Density = 1.0
        RState.Fog_Start = 100
        RState.Fog_End = 1500
        RState.Fog_Property(eFog_Mode.LINEAR, eFog_Type.Table)
        RState.Fog_Color = Color.SkyBlue
        RState.Fog_Enable = True

        'on créé une lumière
        myLight = New Light.TZLight("mylight")

        'on utilise une fonction facilitante pour remplir rapidement les valeurs de mylight
        'afin d'obtenir une lumière directionnel
        Light.TZLightManager.GetInstance.Create_DirectionalLight(New Vector3(-1, -1, 1), myLight)
        myLight.Diffuse = Color.White
        myLight.Ambient = Get_Color(0.2, 0.2, 0.2, 1)
        'et on allume la lumière
        Light.TZLightManager.GetInstance.Lightning = True

        'on créé notre camera
        myCamera = New Scene.TZCamera("myCamera")

        'on configure la camera
        myCamera.Perspective(75, Engine.Viewport_Width / Engine.Viewport_Height, 1, 2000)

        'camera en mode FPS (pas de prise en charge du Roll
        myCamera.Set_Mode(eCameraMode.First_Person)

        'la camera est défini dans la boucle de rendu suivant la position du perso

        myText = New Graphics.TZText("verdanna", 10, FontStyle.Regular)

        Render3D()
    End Sub

    Private Sub Render3D()

        'attend que tout est chargé
        Engine.WaitLoad(False, False, True)

        'debut de la boucle de rendu
        Do While Engine.DoRender
            Application.DoEvents()

            's'il n'y a pas de perte du device on peu commencer le rendu
            If Engine.TestCooperativeLevel Then
                myActor.Position = New Vector3(myActor.Position.X, myTerrain.Altitude(myActor.Position.X, myActor.Position.Z), myActor.Position.Z)
                User_Input()

                'on indique au moteur qu'il faut regarder à partir de notre camera            
                Engine.Camera_Update(myCamera, False)

                'début du rendu
                Engine.Render_Begin()

                'effacement du backbuffer avec une couleur
                Engine.Render_Clear(Color.BlueViolet)

                'rendu de la skybox
                mySkybox.Render()

                myActor.Update()
                myActor.Render()

                myTerrain.Update()
                myTerrain.Render()

                myText.Write("Z, S : Deplacement du personnage", New Vector2(140, Engine.Viewport_Height - 30), Color.Red)
                'fin du rendu
                Engine.Render_End()

            End If

        Loop

        'on decharge le moteur et tout ses composants interne
        Engine.Dispose()

        Application.Exit()

    End Sub

    Dim Theta As Single = (3.0F * Math.PI) / 2.0F
    Dim Phi As Single = Math.PI / 2

    Private Sub User_Input()
        If Input.Key(eKeyboard.Echap) Then Engine.Quit()

        If Input.Key_Pressed(eKeyboard.Grave, True) Then
            Engine.Display_Console = Not Engine.Display_Console
        End If
        If Input.Key_Pressed(eKeyboard.F1) Then
            Engine.Display_FPS = Not Engine.Display_FPS
        ElseIf Input.Key_Pressed(eKeyboard.F2) Then
            Engine.Render_BoundingBox = Not Engine.Render_BoundingBox    
        End If
        If Engine.Display_Console = True Then
            Engine.Console_Write = Input.Key_Pressed

            'agrandi la console au maximum
            If Input.Key(eKeyboard.Home) Then
                Engine.Console_Maximize()

                'agrandi la console à la moitié de l'écran
            ElseIf Input.Key(eKeyboard.Ends) Then
                Engine.Console_Normal()
            End If

            If Input.Key(eKeyboard.Page_Up) Then
                Engine.Console_ScrollLine -= 1
            ElseIf Input.Key(eKeyboard.Page_Down) Then
                Engine.Console_ScrollLine += 1
            End If

        Else
            Camera_Speed = Camera_Speed_Def * Engine.DeltaTime
            Camera_MouseState = Input.Get_MouseState

            Dim mov_vert, mov_hori As Single

            Dim RightVec As Vector3 = Vector3.Rotate(myActor.Right, New Vector3(0, -90, 0)) 
            If Input.Key(eKeyboard.Z) Then
                myActor.Set_Animation(1)

                'joue l'animation à l'endroit
                myActor.Animation_Time = 1

                myActor.Position += RightVec * (Actor_Speed * Engine.DeltaTime)
                Rotate_ActorFromCam()

            ElseIf Input.Key(eKeyboard.S) Then                
                myActor.Set_Animation(1)
                myActor.Position -= RightVec * (Actor_Speed * Engine.DeltaTime)

                'joue l'animation à l'envers
                myActor.Animation_Time = -1
                Rotate_ActorFromCam()

            Else
                myActor.Set_Animation(3)
            End If

            If Input.Key(eKeyboard.Q) Then
                mov_vert = 0 : mov_hori = -1
            ElseIf Input.Key(eKeyboard.D) Then
                mov_vert = 0 : mov_hori = 1
            End If
            mov_vert = -Camera_MouseState.Y
            mov_hori = -Camera_MouseState.X
            Camera_distance += Camera_MouseState.Z
            If Camera_distance < 2 Then Camera_distance = 2
            Rotate_Around_Point(myCamera, myActor.Position + New Vector3(0, 5, 0), Camera_distance, mov_vert, mov_hori)

            Dim terr_alti As Single = myTerrain.Altitude(myCamera.Position.X, myCamera.Position.Z) + 1
            If myCamera.Position.Y < terr_alti Then
                myCamera.Position = New Vector3(myCamera.Position.X, terr_alti, myCamera.Position.Z)
            End If
        End If

    End Sub

    Private Sub Rotate_ActorFromCam()
        myActor.Rotate_Y(TZGlobal.RadtoDeg(Math.Atan2(myCamera.Look.X, myCamera.Look.Z)))
    End Sub

    Private Sub Rotate_Around_Point(ByVal Camera As Scene.TZCamera, ByVal Target As Vector3, ByVal radius As Single, ByVal Move_Vert As Single, ByVal Move_Hori As Single)
        ' If Move_Vert = 0 And Move_Hori = 0 Then Exit Sub
        Dim Cx, Cy, Cz As Single

        If Move_Hori < 0 Then
            Theta -= Camera_Speed_Def * Engine.DeltaTime
        ElseIf Move_Hori > 0 Then
            Theta += Camera_Speed_Def * Engine.DeltaTime
        End If

        If Move_Vert < 0 Then
            Phi -= Camera_Speed_Def * Engine.DeltaTime
        ElseIf Move_Vert > 0 Then
            Phi += Camera_Speed_Def * Engine.DeltaTime
        End If
        If Phi > Math.PI - 0.2 Then Phi = Math.PI - 0.2
        If Phi < 0.2 Then Phi = 0.2

        Cx = radius * Math.Cos(Theta) * Math.Sin(Phi)
        Cy = radius * Math.Cos(Phi)
        Cz = radius * Math.Sin(Theta) * Math.Sin(Phi)

        Camera.LookAt(Target + New Vector3(Cx, -Cy, Cz), Target, New Vector3(0, 1, 0))
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If Engine.DoRender = True Then
            e.Cancel = True

            'indique au moteur que l'on veut quitter
            Engine.Quit()
            'et quant il est pret il passe la valeur Engine.DoRender à False
        End If
    End Sub
End Class
